with Interfaces; use Interfaces;

package body CORBA_Repository_Root_Container_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 8, 13);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (0, 27, 9, 19);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (20, 25, 18, 37);

   G : constant array (0 .. 48) of Unsigned_8 :=
     (19, 0, 0, 0, 0, 12, 13, 0, 0, 7, 14, 0, 16, 0, 0, 2, 15, 4, 22, 0, 0,
      3, 9, 0, 0, 0, 0, 0, 0, 0, 10, 13, 9, 19, 0, 0, 1, 0, 0, 0, 14, 0, 6,
      15, 0, 18, 12, 0, 13);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 49;
         F2 := (F2 + Natural (T2 (K)) * J) mod 49;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 24;
   end Hash;

end CORBA_Repository_Root_Container_Hash;
